/**********************************************************************/
/*
     FILE: stack.c
  PURPOSE: To define the stack ADT.
   AUTHOR: Peter Hollemans
     DATE: 06/03/1999
  CHANGES: n/a

*/
/**********************************************************************/

/* include files */

#include <stdio.h>
#include <stdlib.h>
#include "stack.h"

/* functions */

void stackinit (stack *s) { *s = NULL; }

void *stackpop (stack *s) { 
  void *data;
  stack below;
  if (*s != NULL) {
    data = (*s)->data;        
    below = (*s)->below;    
    free (*s);
    *s = below;
    return (data);
  } /* if */
  else
    return (NULL);
} /* stackpop */

void stackpush (stack *s, void *data) {
  stack new_stack;
  if ((new_stack = malloc (sizeof (stack_struct_var))) == NULL) {
    fprintf (stderr, "stackpush: memory allocation failed\n");
    exit (-1);
  } /* if */
  new_stack->data = data;
  new_stack->below = *s;
  *s = new_stack;
} /* stackpush */

int stackempty (stack s) { return (s == NULL); }

/**********************************************************************/
